searchNodes=[{"doc":"This module provides the main APIs for Kafkaesque Introduction Kafkaesque is an outbox library built for PostgreSQL and designed, primarily, for Kafka, though usage with other software is possible and encouraged. Transactional safety for messages: if they were created, they will be eventually published. They're only created if the transaction commits. Ordering: messages are published sequentially for topic/partition combinations Shutdown safety: has graceful shutdown and rescue for cases where it doesn't happen. Observability: all operations publish telemetry events. Garbage collection: outbox table is periodically cleaned. Multi-node safe: safety powered by PostgreSQL. For a comprehensive installation guide, check the Getting started guide. Note For most cases, this module shouldn't be called directly. Instead, you want to use it to define an outbox for your application, and call the outbox, as you do with Ecto repos.","ref":"Kafkaesque.html","title":"Kafkaesque","type":"module"},{"doc":"Child spec for a Kafkaesque instance","ref":"Kafkaesque.html#child_spec/1","title":"Kafkaesque.child_spec/1","type":"function"},{"doc":"Publishes a message in the outbox. While you can use this function, this is not the recommended approach to use the library. See the documentation of the Kafkaesque module for more information.","ref":"Kafkaesque.html#publish/4","title":"Kafkaesque.publish/4","type":"function"},{"doc":"Starts a Kafkaesque instance. Accepts the following opts: :repo : the repo where messages will be read from. Usually should be the same repo that you're writing to. :client : the client to be used by the publisher. Defaults to Kafkaesque.Clients.BrodClient :client_opts : the options to be used by the client. Defaults to [] . The default client requires options, so this can be considered required for most use-cases. Look at the client documentation for more information about the client options. :producer_max_backoff_ms : maximum time in milliseconds that the producer will take between database reads. Notice that this is edge-case scenario and should only happen when a) there are database issues or b) there are no new messages in the table for long. :publisher_max_demand : maximum publisher demand, can be useful for tuning. Defaults to 200. See GenStage documentation for more info. :publisher_min_demand : minimum publisher demand, can be useful for tuning. Defaults to 190. See GenStage documentation for more info. :rescuer_interval_ms : the interval between garbage collection runs. Defaults to 15 seconds. Notice that it always runs on tree startup. rescuer_limit_ms : the time limit for records to be in the publishing state. Defaults to 15 seconds. Notice that they may stay longer in this state due to the interval. :garbage_collector_interval_ms : the interval between garbage collection runs. Defaults to 30 seconds. Notice that it always runs on tree startup. garbage_colletor_limit_ms : the time limit for published records to be in the table. Defaults to 72 hours. query_opts : Options to pass to Ecto queries. Defaults to [log: false]","ref":"Kafkaesque.html#start_link/1","title":"Kafkaesque.start_link/1","type":"function"},{"doc":"Stage that updates in the database the messages that were published in Kafka Takes 3 options: :publisher_pid : pid of the stage that will publish the messages. :repo : the repo to execute the queries on. :query_opts : A list of options sent to Repo calls.","ref":"Kafkaesque.Acknowledger.html","title":"Kafkaesque.Acknowledger","type":"module"},{"doc":"","ref":"Kafkaesque.Acknowledger.html#shutdown/2","title":"Kafkaesque.Acknowledger.shutdown/2","type":"function"},{"doc":"","ref":"Kafkaesque.Acknowledger.html#start_link/1","title":"Kafkaesque.Acknowledger.start_link/1","type":"function"},{"doc":"Behaviour for clients","ref":"Kafkaesque.Client.html","title":"Kafkaesque.Client","type":"behaviour"},{"doc":"","ref":"Kafkaesque.Client.html#c:publish/2","title":"Kafkaesque.Client.publish/2","type":"callback"},{"doc":"","ref":"Kafkaesque.Client.html#c:start_link/1","title":"Kafkaesque.Client.start_link/1","type":"callback"},{"doc":"","ref":"Kafkaesque.Client.html#t:client/0","title":"Kafkaesque.Client.client/0","type":"type"},{"doc":"Basic client implementation using brod Produces synchronously, and automatically starts all the required producers. Required options: :client_id : An atom which will be used as the client name :brokers : A list of {address, port} tuples for kafka brokers. Addresses should be charlists. Also accepts the same options as :brod.start_client/3","ref":"Kafkaesque.Clients.BrodClient.html","title":"Kafkaesque.Clients.BrodClient","type":"module"},{"doc":"Garbage collects messages that were already published Takes 3 options on startup: :repo : the repo to perform garbage collection on :query_opts : A list of options sent to Repo calls. :garbage_collector_interval_ms : the interval between garbage collection runs. Notice that it always runs on startup. garbage_colletor_limit_ms : the time limit for published records to be in the table.","ref":"Kafkaesque.GarbageCollector.html","title":"Kafkaesque.GarbageCollector","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kafkaesque.GarbageCollector.html#child_spec/1","title":"Kafkaesque.GarbageCollector.child_spec/1","type":"function"},{"doc":"","ref":"Kafkaesque.GarbageCollector.html#start_link/1","title":"Kafkaesque.GarbageCollector.start_link/1","type":"function"},{"doc":"Application-side representation of messages, published or not","ref":"Kafkaesque.Message.html","title":"Kafkaesque.Message","type":"module"},{"doc":"","ref":"Kafkaesque.Message.html#new/3","title":"Kafkaesque.Message.new/3","type":"function"},{"doc":"","ref":"Kafkaesque.Message.html#t:state/0","title":"Kafkaesque.Message.state/0","type":"type"},{"doc":"","ref":"Kafkaesque.Message.html#t:t/0","title":"Kafkaesque.Message.t/0","type":"type"},{"doc":"","ref":"Kafkaesque.Migrations.html","title":"Kafkaesque.Migrations","type":"module"},{"doc":"","ref":"Kafkaesque.Migrations.html#down/0","title":"Kafkaesque.Migrations.down/0","type":"function"},{"doc":"","ref":"Kafkaesque.Migrations.html#up/0","title":"Kafkaesque.Migrations.up/0","type":"function"},{"doc":"This process just initializes the stages, linked to it. If one stage die, all stages die. It also takes care of termination of the stages.","ref":"Kafkaesque.Pipeline.html","title":"Kafkaesque.Pipeline","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kafkaesque.Pipeline.html#child_spec/1","title":"Kafkaesque.Pipeline.child_spec/1","type":"function"},{"doc":"","ref":"Kafkaesque.Pipeline.html#start_link/1","title":"Kafkaesque.Pipeline.start_link/1","type":"function"},{"doc":"Queries the database for messages to be published Takes 2 options on startup: :producer_max_backoff_ms : maximum time in milliseconds that the producer will take between database reads. Notice that this is edge-case scenario and should only happen when a) there are database issues or b) there are no new messages in the table for long. :repo : the repo the producer will query on. :query_opts : A list of options sent to Repo calls.","ref":"Kafkaesque.Producer.html","title":"Kafkaesque.Producer","type":"module"},{"doc":"","ref":"Kafkaesque.Producer.html#shutdown/2","title":"Kafkaesque.Producer.shutdown/2","type":"function"},{"doc":"","ref":"Kafkaesque.Producer.html#start_link/1","title":"Kafkaesque.Producer.start_link/1","type":"function"},{"doc":"","ref":"Kafkaesque.Producer.html#stop_producing/1","title":"Kafkaesque.Producer.stop_producing/1","type":"function"},{"doc":"Stage that publishes messages in Kafka Takes 3 options: :repo : the repo associated with the Kafkaesque instance :producer_pid : pid of the stage that will produce the messages. :client : the client module that will be used to publish the messages. Defaults to Kafkaesque.Clients.BrodClient . :client_opts : A list of options to be passed to the client on startup. Defaults to [] . The default client requires options, so this can be considered required for most use-cases. :publisher_min_demand : The minimum demand. See GenStage documentation for more info. Defaults to 190. :publisher_min_demand : The maximum demand. See GenStage documentation for more info. Defaults to 200.","ref":"Kafkaesque.Publisher.html","title":"Kafkaesque.Publisher","type":"module"},{"doc":"","ref":"Kafkaesque.Publisher.html#shutdown/2","title":"Kafkaesque.Publisher.shutdown/2","type":"function"},{"doc":"","ref":"Kafkaesque.Publisher.html#start_link/1","title":"Kafkaesque.Publisher.start_link/1","type":"function"},{"doc":"Rescues messages stuck in publishing state If the shutdown wasn't graceful or there are errors, there is the possibility that messages get lost in the :publishing state, which would stop the publishing for a topic + partition combination. This process rescues the stuck messages periodically. Takes 3 options on startup: :repo : the repo to perform garbage collection on :query_opts : A list of options sent to Repo calls. :rescuer_interval_ms : the interval between garbage collection runs. Notice that it always runs on tstartup. rescuer_limit_ms : the time limit for records to be in the publishing state. Notice that they may stay longer in this state due to the interval.","ref":"Kafkaesque.Rescuer.html","title":"Kafkaesque.Rescuer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kafkaesque.Rescuer.html#child_spec/1","title":"Kafkaesque.Rescuer.child_spec/1","type":"function"},{"doc":"","ref":"Kafkaesque.Rescuer.html#start_link/1","title":"Kafkaesque.Rescuer.start_link/1","type":"function"},{"doc":"Supervisor for Kafkaesque","ref":"Kafkaesque.Supervisor.html","title":"Kafkaesque.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Kafkaesque.Supervisor.html#child_spec/1","title":"Kafkaesque.Supervisor.child_spec/1","type":"function"},{"doc":"Callback implementation for Supervisor.init/1 .","ref":"Kafkaesque.Supervisor.html#init/1","title":"Kafkaesque.Supervisor.init/1","type":"function"},{"doc":"","ref":"Kafkaesque.Supervisor.html#start_link/1","title":"Kafkaesque.Supervisor.start_link/1","type":"function"},{"doc":"First, you need to migrate your database to create the outbox. Create a migration with Ecto and add the following: defmodule MyApp.Repo.Migrations.AddKafkaesque def up do Kafkaesque.Migrations . up ( ) end def down do Kafkaesque.Migrations . down ( ) end end Then, you must define an outbox module, associated with the Repo you ran the Kafkaesque migrations on. For example: defmodule MyApp.Outbox do use Kafkaesque , repo : MyApp.Repo # Optional, sets the partition for the message. Should return an integer # Defaults to returning 0. def partition ( _topic , _body ) do Enum . random ( 0 .. 1 ) end # Optional, encodes the body of the message, should return a String. # Defaults to the identity function. def encode ( body ) do Jason . encode! ( body ) end end Finally, you should start a Kafkaesque instance in your supervision tree. For example: defmodule MyApp.Application do def start ( _type , _args ) do children = [ MyApp.Repo , { MyApp.Outbox , [ client_opts : [ client_id : :my_client , brokers : [ { &quot;localhost, 9092&quot; } ] ] ] } , ] end end Done! Now you can publish messages. Try it out with: MyApp.Outbox . publish ( &quot;topic&quot; , %{ hello : :kafka } ) `","ref":"getting-started.html","title":"Getting started","type":"extras"}]